# -*- coding: utf-8 -*-
from setuphelpers import *

services_to_disabled = {
    "BTAGService":{"description":"Bluetooth Audio Gateway Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "bthserv":{"description":"Bluetooth Support Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    #"Browser":{"description":"Computer Browser","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "MapsBroker":{"description":"Downloaded Maps Manager","service_default_startup":"auto","service_recommended_startup":"Disabled","registry_default_value":2,"registry_recommended_value":4},
    "lfsvc":{"description":"Geolocation Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "IISADMIN":{"description":"IIS Admin Service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "irmon":{"description":"Infrared monitor service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "SharedAccess":{"description":"Internet Connection Sharing (ICS)","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "lltdsvc":{"description":"Link-Layer Topology Discovery Mapper","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "LxssManager":{"description":"LxssManager","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "FTPSVC":{"description":"Microsoft FTP Service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "MSiSCSI":{"description":"Microsoft iSCSI Initiator Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "sshd":{"description":"OpenSSH SSH Server","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "PNRPsvc":{"description":"Peer Name Resolution Protocol","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "p2psvc":{"description":"Peer Networking Grouping","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "p2pimsvc":{"description":"Peer Networking Identity Manager","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "PNRPAutoReg":{"description":"PNRP Machine Name Publication Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "Spooler":{"description":"Print Spooler","service_default_startup":"auto","service_recommended_startup":"Disabled","registry_default_value":2,"registry_recommended_value":4},
    "wercplsupport":{"description":"Problem Reports and Solutions Control Panel Support","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "RasAuto":{"description":"Remote Access Auto Connection Manager","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "SessionEnv":{"description":"Remote Desktop Configuration","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "UmRdpService":{"description":"Remote Desktop Services UserMode Port Redirector","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "RpcLocator":{"description":"Remote Procedure Call (RPC) Locator","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "RemoteRegistry":{"description":"Remote Registry","service_default_startup":"Disabled","service_recommended_startup":"Disabled","registry_default_value":4,"registry_recommended_value":4},
    "RemoteAccess":{"description":"Routing and Remote Access","service_default_startup":"Disabled","service_recommended_startup":"Disabled","registry_default_value":4,"registry_recommended_value":4},
    "LanmanServer":{"description":"Server","service_default_startup":"auto","service_recommended_startup":"Disabled","registry_default_value":2,"registry_recommended_value":4},
    "simptcp":{"description":"Simple TCP/IP Services","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "SNMP":{"description":"SNMP Service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "sacsvr":{"description":"Special Administration Console Helper","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "SSDPSRV":{"description":"SSDP Discovery","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "upnphost":{"description":"UPnP Device Host","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "WMSvc":{"description":"Web Management Service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "WerSvc":{"description":"Windows Error Reporting Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "Wecsvc":{"description":"Windows Event Collector","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "WMPNetworkSvc":{"description":"Windows Media Player Network Sharing Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "icssvc":{"description":"Windows Mobile Hotspot Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "WpnService":{"description":"Windows Push Notifications System Service","service_default_startup":"auto","service_recommended_startup":"Disabled","registry_default_value":2,"registry_recommended_value":4},
    "PushToInstall":{"description":"Windows PushToInstall Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "WinRM":{"description":"Windows Remote Management (WS-Management)","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "W3SVC":{"description":"World Wide Web Publishing Service","service_default_startup":None,"service_recommended_startup":"Disabled","registry_default_value":None,"registry_recommended_value":4},
    "XboxGipSvc":{"description":"Xbox Accessory Management Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "XblAuthManager":{"description":"Xbox Live Auth Manager","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "XblGameSave":{"description":"XblGameSave","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "XboxNetApiSvc":{"description":"Xbox Live Networking Service","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
    "TermService":{"description":"Remote Desktop Services","service_default_startup":"demand","service_recommended_startup":"Disabled","registry_default_value":3,"registry_recommended_value":4},
}

def install():
    for service in services_to_disabled:
        if service_installed(service):                
            print(f"Disable {services_to_disabled[service]['description']} ({service})")
            if service_is_running(service):
                try:
                    service_stop(service)
                except:
                    print(f"Unable to stop {service}, please restart your computer")
            run(rf'sc config "{service}" start= {services_to_disabled[service]["service_recommended_startup"].lower()}')
            registry_set(HKEY_LOCAL_MACHINE,r'SYSTEM\CurrentControlSet\Services',service,services_to_disabled[service]['registry_recommended_value'])


def uninstall():
    for service in services_to_disabled:
        if service_installed(service):
            print(f"Set default value for {services_to_disabled[service]['description']} ({service})")
            if services_to_disabled[service]['service_default_startup'] is not None:
                run(rf'sc config "{service}" start= {services_to_disabled[service]["service_default_startup"].lower()}')
                registry_set(HKEY_LOCAL_MACHINE,r'SYSTEM\CurrentControlSet\Services',service,services_to_disabled[service]['registry_default_value'])


def audit():
    error = False
    service_in_fault = []
    for service in services_to_disabled:
        if service_installed(service):
            current_value = registry_readstring(HKEY_LOCAL_MACHINE,r'SYSTEM\CurrentControlSet\Services',service)
            expected_value = str(services_to_disabled[service]['registry_recommended_value'])
            if current_value != expected_value:
                print(f"Service {service} isn't in correct value : {current_value} expected {expected_value}")
                service_in_fault.append(service)
                error = True

    if error:
        WAPT.write_audit_data_if_changed("CIS disable services", 'Service in fault', parameter_in_fault, keep_days=365)
        return "ERROR"
    else:
        WAPT.write_audit_data_if_changed("CIS disable services", 'Service in fault', "OK", keep_days=365)
        return "OK"


